// Cube.java
//
// Copyright (C) 1995 Dimension X, Inc.
//   Chris Laurel 10-28-95
//
// This code may be redistributed freely.
//
//
//  This code is made distributed by Vishal Mehra 08/09/96
//

import java.applet.Applet;
import java.awt.*;
import dnx.geom.Matrix4;
import dnx.ice.*;
import java.io.*;
import java.net.*;


public class Cube extends Applet
{
   Graphics3D g3d;
   Model cube;
   float xangle, yangle;
   int lastX, lastY;
   Matrix4 t = new Matrix4();
   startGraphics3DServer cubeServer;


   public void init()
   {
      cube = createBox(2, 2, 2);
 cubeServer =     new startGraphics3DServer("128.230.7.14",9010,this);
   }

   public void start()
   {
      createGraphicsContext();
      display();
   }

   public synchronized void display()
   {
      // Clear the contents of the frame buffer
      g3d.clear(Graphics3D.COLOR_BUFFER);

      // Set up the model transformation
      t.identity();
      // translate the cube away from the camera along the z axis
      t.translate(0, 0, -5);
      // rotate it
      t.xrotate(xangle);
      t.yrotate(yangle);

      // render
      g3d.concatModelMatrix(t);
      g3d.renderSolid(cube);
      g3d.popModelMatrix();

      repaint();
   }

   
   // Standard applet methods
   public boolean mouseDown(Event e, int x, int y)
   {
      lastX = x;
      lastY = y;
      return true;
   }

   public boolean mouseDrag(Event e, int x, int y)
   {
      yangle += (float) (x - lastX) / (float) size().width * (float) Math.PI;
      xangle += (float) (y - lastY) / (float) size().height * (float) Math.PI;
      lastX = x;
      lastY = y;
//      display();

     cubeServer.sendMessage( new Float(yangle).toString());
     cubeServer.sendMessage( new Float(xangle).toString());
     cubeServer.sendMessage( new Integer(lastX).toString());
     cubeServer.sendMessage( new Integer(lastY).toString());
      return true;
   }

   public void paint(Graphics g)
   {
      update(g);
   }

   public void update(Graphics g)
   {
      if (g3d != null)
	 g3d.paint(g, 0, 0);
   }


   private void createGraphicsContext()
   {
      // Create a new 3D graphics context . . . since we're just
      //   going to be rendering a cube, we don't need a depth
      //   buffer--all necessary hidden surface removal is handled
      //   by backface culling.
      g3d = new Graphics3D(this,
			   Graphics3D.COLOR_BUFFER,
			   size().width, size().height);

      // Set the clear color to be light gray (generally, the same
      //   color as the main browser window)
      g3d.setClearColor(Color.lightGray);

      g3d.disableLighting();

      // Enable dithering, if necessary.  This will only have an effect
      //   for a non-truecolor display.
      g3d.enableDithering();
   }


   // Create a box model centered about the origin.
   Model createBox(int width, int height, int depth)
   {
      try {
	 // Create a new, empty model with per vertex materials,
	 //   no normals (we're just using emissiveColor so we
	 //   don't need them for lighting), and no texture
	 //   coordinates;
	 Model m = new Model(Model.BINDING_PER_VERTEX,
			     Model.BINDING_NONE,
			     false);

	 // Add the vertices
	 m.addVertex(-width / 2, -height / 2, depth / 2);
	 m.addVertex(-width / 2, height / 2, depth / 2);
	 m.addVertex(-width / 2, height / 2, -depth / 2);
	 m.addVertex(-width / 2, -height / 2, -depth / 2);
	 m.addVertex(width / 2, -height / 2, depth / 2);
	 m.addVertex(width / 2, height / 2, depth / 2);
	 m.addVertex(width / 2, height / 2, -depth / 2);
	 m.addVertex(width / 2, -height / 2, -depth / 2);

	 // Add the materials
	 Material mat = new Material(Color.white, Color.black,
				     Color.black, Color.black,
				     1, 1);
	 mat.setEmissive(0, 0, 1);   m.addMaterial(mat);
	 mat.setEmissive(1, 0, 0);   m.addMaterial(mat);
	 mat.setEmissive(0, 1, 0);   m.addMaterial(mat);
	 mat.setEmissive(1, 1, 1);   m.addMaterial(mat);
	 mat.setEmissive(0, 1, 1);   m.addMaterial(mat);
	 mat.setEmissive(1, 1, 0);   m.addMaterial(mat);
	 mat.setEmissive(1, 0, 1);   m.addMaterial(mat);
	 mat.setEmissive(0.5f, 0.5f, 0.5f);  m.addMaterial(mat);

	 // Add the faces.  vi is an array which will contain the
	 //   vertex indices for each face.  Since each vertex is
	 //   mapped to one material, we can use the same array
	 //   for the material indices.
	 int vi[] = new int[4];
	 vi[0] = 0; vi[1] = 1; vi[2] = 2; vi[3] = 3;
	 m.polygon(4, vi, vi, null, null); // left (-X)
	 vi[0] = 7; vi[1] = 6; vi[2] = 5; vi[3] = 4;
	 m.polygon(4, vi, vi, null, null); // right (+X)
	 vi[0] = 4; vi[1] = 5; vi[2] = 1; vi[3] = 0;
	 m.polygon(4, vi, vi, null, null); // front (+Z)
	 vi[0] = 3; vi[1] = 2; vi[2] = 6; vi[3] = 7;
	 m.polygon(4, vi, vi, null, null); // back (-Z)
	 vi[0] = 1; vi[1] = 5; vi[2] = 6; vi[3] = 2;
	 m.polygon(4, vi, vi, null, null); // top (+Y)
	 vi[0] = 3; vi[1] = 7; vi[2] = 4; vi[3] = 0;
	 m.polygon(4, vi, vi, null, null); // bottom (-Y)

	 return m;
      } catch (InvalidModelException e) {
	 return null;
      }

   }

}

class startGraphics3DServer extends Thread{
       Socket newSocket;
       String message = new String();
       String from = new String();
       int port;
       int i;
       DataInputStream receive ;
       PrintStream send;
       DataInputStream kb;
        Cube cube;


       public startGraphics3DServer(String _from ,int  _port,Cube _cube ){
       from = _from;
       port = _port;
       cube = _cube;
       System.out.println(" Before starting thread ");
      this.start();
      }


  public void run(){
      int i,j;
      Socket server;
int x1=0,x2=0,y1=0,y2=0;
int mode=0;
int index=0;
String s = new String("An error has occured");

       System.out.println(" Before connect ");

      try{
       server = new Socket("128.230.7.14",port);
       receive = new DataInputStream(server.getInputStream());
       send = new PrintStream(server.getOutputStream());
       }
       catch(java.io.IOException e2){}

       System.out.println(" After connect ");


       boolean validLogin = false;

       System.out.println(" Before whileLoop ");

    System.out.println( "Before Received ");

while(true){
      try{
           cube.yangle  = Float.valueOf(receive.readLine()).floatValue();
           cube.xangle  = Float.valueOf(receive.readLine()).floatValue();
           cube.lastX  =  Integer.valueOf(receive.readLine()).intValue();
           cube.lastY  =  Integer.valueOf(receive.readLine()).intValue();
           cube.display();
         }
       catch(java.io.IOException e2){}

     }
 }


  public void sendMessage(String s){
       send.println(s);
   }

}



